<div id="payment-method">
  <div class="pa-0 pb-md-8">
    <div class="flex flex-wrap items-center justify-between">
      <p class="mb-0 text-xl font-semibold text-neutral-900">Payment Methods</p>
      <v-btn
        color="#3B82F6"
        class="elevation-0 rounded-md my-3 my-md-0"
        height="40"
        v-if="listPayment.length && !loadingTable"
        @click="openDialogAddPayment()"
      >
        <div class="flex items-center">
          <v-icon color="#fff" small> mdi-card-plus </v-icon>
          <p class="mb-0 ml-2 capitalize font-medium text-white">
            Add Payment Method
          </p>
        </div>
      </v-btn>
    </div>
    <div class="mt-2">
      <v-card class="ui-card rounded-t-lg pb-4">
        <v-skeleton-loader
          class="mx-auto mt-10"
          width="100%"
          type="card"
          v-if="loadingTable"
        >
        </v-skeleton-loader>
        <v-simple-table class="scrollTable c-pointer" fixed-header v-else>
          <template v-slot:default>
            <thead>
              <tr>
                <th class="table-head" style="width: 100px">
                  <div class="d-flex align-center">
                    <p class="mb-0 captionOverline text-content-main text-sm">
                      Status
                    </p>
                  </div>
                </th>
                <th class="table-head text-left">
                  <div style="width: 200px">
                    <p class="mb-0 captionOverline text-content-main text-sm">
                      Type
                    </p>
                  </div>
                </th>
                <th class="table-head text-left">
                  <div style="width: 200px">
                    <p class="mb-0 captionOverline text-content-main text-sm">
                      Payment Providers
                    </p>
                  </div>
                </th>
                <th class="table-head text-left">
                  <div class="w-[200px]">
                    <p class="mb-0 captionOverline text-content-main text-sm">
                      # Applied Sellers
                    </p>
                  </div>
                </th>
                <th class="table-head text-left">
                  <div>
                    <p class="mb-0 captionOverline text-content-main text-sm">
                      Amount
                    </p>
                  </div>
                </th>
                <th class="table-head text-left">
                  <div>
                    <p class="mb-0 captionOverline text-content-main text-sm">
                      Policy
                    </p>
                  </div>
                </th>
                <th class="table-head text-left">
                  <div>
                    <p class="mb-0 captionOverline text-content-main text-sm">
                      Action
                    </p>
                  </div>
                </th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="(payment,i) in listPayment" :key="payment._id">
                <td class="py-3">
                  <v-switch
                    inset
                    v-model="payment.enabled"
                    @change="onChangeStatus(payment)"
                  ></v-switch>
                </td>
                <td
                  @click="$router.push(`/admin/settings/payment-method/detail/${payment._id}`)"
                >
                  <div class="flex items-center">
                    <div class="!w-9 h-9" v-if="payment.type === 'paypal'">
                      <img
                        src="~/assets/images/logos_paypal.svg"
                        alt=""
                        class="w-full h-full object-scale-down"
                      />
                    </div>
                    <div class="!w-9 h-9" v-if="payment.type === 'stripe'">
                      <img
                        src="~/assets/images/bi_stripe.svg"
                        alt=""
                        class="w-full h-full object-scale-down"
                      />
                    </div>
                    <p
                      class="mb-0 ml-2 text-sm font-semibold text-neutral-900"
                      v-if="payment.type === 'paypal'"
                    >
                      Paypal
                    </p>
                    <p
                      class="mb-0 ml-2 text-sm font-semibold text-neutral-900"
                      v-if="payment.type === 'stripe'"
                    >
                      Stripe
                    </p>
                  </div>
                </td>
                <td
                  class="py-3"
                  @click="$router.push(`/admin/settings/payment-method/detail/${payment._id}`)"
                >
                  <p class="mb-0 text-sm font-semibold text-neutral-900">
                    {{payment.name}}
                  </p>
                </td>
                <td
                  class="py-3"
                  @click="$router.push(`/admin/settings/payment-method/detail/${payment._id}`)"
                >
                  <p class="mb-0 text-sm text-neutral-900">
                    {{payment.countSeller &&
                    $utils.formatCurrencyFloat(payment.countSeller)}}
                  </p>
                </td>
                <td
                  class="py-3"
                  @click="$router.push(`/admin/settings/payment-method/detail/${payment._id}`)"
                >
                  <p class="mb-0 text-sm text-neutral-900">
                    ${{payment.amount &&
                    $utils.formatCurrencyFloat(payment.amount)}}
                  </p>
                </td>
                <td
                  class="py-3"
                  @click="$router.push(`/admin/settings/payment-method/detail/${payment._id}`)"
                >
                  <div class="flex items-center justify-start">
                    <p class="mb-0">{{calcLengthPolicy(payment)}}/9</p>
                    <div class="ml-2">
                      <v-icon
                        color="#22C55E"
                        v-if="calcLengthPolicy(payment) === 9"
                      >
                        mdi-check-circle
                      </v-icon>
                      <v-icon
                        color="#F59E0B"
                        v-if="calcLengthPolicy(payment) > 0 && calcLengthPolicy(payment) < 9"
                      >
                        mdi-close-circle
                      </v-icon>
                      <v-icon
                        color="#EF4444"
                        v-if="calcLengthPolicy(payment) === 0"
                      >
                        mdi-close-circle
                      </v-icon>
                    </div>
                  </div>
                </td>
                <td class="py-3">
                  <v-icon
                    color="#111827"
                    size="20"
                    class="bg-gray-200 p-1.5 rounded"
                    @click="openDialogDuplicate(payment)"
                  >
                    mdi-content-copy
                  </v-icon>
                </td>
              </tr>
            </tbody>
          </template>
        </v-simple-table>
        <div
          class="d-flex justify-center ma-4"
          v-if="listPayment.length == 0 && !loadingTable"
        >
          <div>
            <div class="d-flex align-center justify-center">
              <img
                src="~/assets/images/payment/no-payment.png"
                alt=""
                width="136"
                height="136"
              />
            </div>
            <p
              class="mb-0 mt-4 text-center text-sm text-gray-500 font-semibold"
            >
              No Payment
            </p>
            <p class="mb-0 text-center text-xs text-gray-500">
              Add a payment method for your customers to pay you.
            </p>
            <div class="mt-12 flex justify-center">
              <v-btn
                color="#3B82F6"
                class="elevation-0 rounded-md"
                height="44"
                @click="openDialogAddPayment()"
              >
                <p class="mb-0 text-white text-sm capitalize">
                  Add Payment Method
                </p>
              </v-btn>
            </div>
          </div>
        </div>
        <div
          class="text-center mt-4 pb-2 d-sm-flex align-center justify-center"
          v-if="listPayment.length && !loadingTable"
        >
          <v-pagination
            v-model="config.page"
            :length="totalPage"
            :total-visible="5"
            class="pagination"
          >
          </v-pagination>
          <div
            id="hideBottomInput"
            class="input-gotopage pos-relative px-3 px-sm-0 mt-3 mt-sm-0"
          >
            <v-text-field
              dense
              outlined
              v-model.number="page"
              placeholder="Go to page"
            >
            </v-text-field>
            <div class="button-inside-input">
              <v-btn
                height="36px"
                color="#076CE3"
                class="px-0 button-inside-input__button elevation-0"
                @click="onRedirectPage()"
              >
                <v-icon color="#ffffff"> mdi-chevron-right </v-icon>
              </v-btn>
            </div>
          </div>
        </div>
      </v-card>
    </div>
  </div>

  <v-row justify="center">
    <v-dialog v-model="dialogAddPayment" :persistent="loading" max-width="640">
      <v-card class="bg-white" id="hideBottomInput">
        <div class="py-5 px-4 flex items-center justify-between">
          <div>
            <p class="mb-0 text-gray-900 font-semibold text-xl">
              Add Payment Method
            </p>
            <span class="text-sm text-gray-900">
              Add new way of receiving payments for sales
            </span>
          </div>
          <v-btn icon small @click="closeDialogAddPayment()">
            <v-icon color="#111827"> mdi-close </v-icon>
          </v-btn>
        </div>
        <v-divider></v-divider>
        <div class="pa-6">
          <div class="grid grid-cols-12">
            <div class="col-span-12 md:col-span-4 flex items-center">
              <p class="mb-0 text-sm text-neutral-900 leading-20 font-semibold">
                Payment Type:
              </p>
            </div>
            <div class="col-span-12 md:col-span-8">
              <v-select
                dense
                outlined
                :items="listPaymentType"
                item-text="name"
                item-value="value"
                v-model="payment.type"
              >
                <template v-slot:prepend-inner>
                  <div class="flex items-center">
                    <img
                      src="~/assets/images/paypal-payment.png"
                      alt=""
                      width="24"
                      height="24"
                      v-if="payment.type === 'paypal'"
                    />
                    <img
                      src="~/assets/images/stripe-payment.png"
                      alt=""
                      width="24"
                      height="24"
                      v-if="payment.type === 'stripe'"
                    />
                  </div>
                </template>
                <template v-slot:item=" {item}">
                  <span class="ml-2">{{item.name}}</span>
                </template>
              </v-select>
            </div>
          </div>
          <div class="grid grid-cols-12 mt-4">
            <div class="col-span-12 md:col-span-4 flex items-center">
              <p class="mb-0 text-sm text-neutral-900 leading-20 font-semibold">
                Method Name:
              </p>
            </div>
            <div class="col-span-12 md:col-span-8">
              <v-text-field
                dense
                outlined
                placeholder="Enter method name"
                v-model="payment.name"
              >
              </v-text-field>
            </div>
          </div>
          <div class="grid grid-cols-12 mt-4">
            <div class="col-span-12 md:col-span-4 flex items-center">
              <p class="mb-0 text-sm text-neutral-900 leading-20 font-semibold">
                Public Key:
              </p>
            </div>
            <div class="col-span-12 md:col-span-8">
              <v-text-field
                dense
                outlined
                placeholder="Enter public key"
                v-model="payment.publicKey"
              >
              </v-text-field>
            </div>
          </div>
          <div class="grid grid-cols-12 mt-4">
            <div class="col-span-12 md:col-span-4 flex items-center">
              <p class="mb-0 text-sm text-neutral-900 leading-20 font-semibold">
                Private Key:
              </p>
            </div>
            <div class="col-span-12 md:col-span-8">
              <v-text-field
                dense
                outlined
                placeholder="Enter private key"
                v-model="payment.secretKey"
              >
              </v-text-field>
            </div>
          </div>
        </div>
        <v-divider></v-divider>
        <div class="flex items-center justify-end py-4 px-6">
          <v-btn
            color="#E5E7EB"
            outlined
            class="elevation-0 mr-3"
            height="44"
            @click="closeDialogAddPayment()"
            :disabled="loading"
          >
            <p class="mb-0 text-sm text-neutral-900 font-semibold capitalize">
              Cancel
            </p>
          </v-btn>
          <v-btn
            color="#3B82F6"
            class="elevation-0"
            height="44"
            @click="onAddPayment()"
            :disabled="loading"
          >
            <v-progress-circular
              indeterminate
              color="#fff"
              v-if="loading"
              size="22"
            >
            </v-progress-circular>
            <p class="mb-0 text-sm text-white font-semibold capitalize" v-else>
              Add Payment Method
            </p>
          </v-btn>
        </div>
      </v-card>
    </v-dialog>
  </v-row>
  <v-row justify="center">
    <v-dialog
      v-model="dialogDuplicatePayment"
      :persistent="loading"
      max-width="640"
    >
      <v-card class="bg-white" id="hideBottomInput">
        <div class="py-5 px-4 flex items-center justify-between">
          <div>
            <p class="mb-0 text-gray-900 font-semibold text-xl">
              Duplicate Policies Payment Method
            </p>
            <span class="text-sm text-gray-900">
              All policies data of this payment method will be copied to a new
              payment
            </span>
          </div>
          <v-btn icon small @click="closeDialogDuplicate()">
            <v-icon color="#111827"> mdi-close </v-icon>
          </v-btn>
        </div>
        <v-divider></v-divider>
        <div class="pa-6">
          <div class="grid grid-cols-12">
            <div class="col-span-12 md:col-span-4 flex items-center">
              <p class="mb-0 text-sm text-neutral-900 leading-20 font-semibold">
                Payment Type:
              </p>
            </div>
            <div class="col-span-12 md:col-span-8">
              <v-select
                dense
                outlined
                :items="listPaymentType"
                item-text="name"
                item-value="value"
                v-model="paymentDuplicate.type"
              >
                <template v-slot:prepend-inner>
                  <div class="flex items-center">
                    <img
                      src="~/assets/images/paypal-payment.png"
                      alt=""
                      width="24"
                      height="24"
                      v-if="paymentDuplicate.type === 'paypal'"
                    />
                    <img
                      src="~/assets/images/stripe-payment.png"
                      alt=""
                      width="24"
                      height="24"
                      v-if="paymentDuplicate.type === 'stripe'"
                    />
                  </div>
                </template>
                <template v-slot:item=" {item}">
                  <span class="ml-2">{{item.name}}</span>
                </template>
              </v-select>
            </div>
          </div>
          <div class="grid grid-cols-12 mt-4">
            <div class="col-span-12 md:col-span-4 flex items-center">
              <p class="mb-0 text-sm text-neutral-900 leading-20 font-semibold">
                Method Name:
              </p>
            </div>
            <div class="col-span-12 md:col-span-8">
              <v-text-field
                dense
                outlined
                placeholder="Enter method name"
                v-model="paymentDuplicate.name"
              >
              </v-text-field>
            </div>
          </div>
          <div class="grid grid-cols-12 mt-4">
            <div class="col-span-12 md:col-span-4 flex items-center">
              <p class="mb-0 text-sm text-neutral-900 leading-20 font-semibold">
                Public Key:
              </p>
            </div>
            <div class="col-span-12 md:col-span-8">
              <v-text-field
                dense
                outlined
                placeholder="Enter public key"
                v-model="paymentDuplicate.publicKey"
              >
              </v-text-field>
            </div>
          </div>
          <div class="grid grid-cols-12 mt-4">
            <div class="col-span-12 md:col-span-4 flex items-center">
              <p class="mb-0 text-sm text-neutral-900 leading-20 font-semibold">
                Private Key:
              </p>
            </div>
            <div class="col-span-12 md:col-span-8">
              <v-text-field
                dense
                outlined
                placeholder="Enter private key"
                v-model="paymentDuplicate.secretKey"
              >
              </v-text-field>
            </div>
          </div>
        </div>
        <v-divider></v-divider>
        <div class="flex items-center justify-end py-4 px-6">
          <v-btn
            color="#E5E7EB"
            outlined
            class="elevation-0 mr-3"
            height="44"
            @click="closeDialogDuplicate()"
            :disabled="loading"
          >
            <p class="mb-0 text-sm text-neutral-900 font-semibold capitalize">
              Cancel
            </p>
          </v-btn>
          <v-btn
            color="#3B82F6"
            class="elevation-0"
            height="44"
            @click="onDuplicatePayment()"
            :disabled="loading"
          >
            <v-progress-circular
              indeterminate
              color="#fff"
              v-if="loading"
              size="22"
            >
            </v-progress-circular>
            <p class="mb-0 text-sm text-white font-semibold capitalize" v-else>
              Duplicate Payment Method
            </p>
          </v-btn>
        </div>
      </v-card>
    </v-dialog>
  </v-row>
</div>
